/* chess_convert.rexx */

/* Converts computer algebraic to standard book algebraic form. */
/*  input the old chess listing's file name as a parameter */

/********************************************************/
/*     Prelims    Prelims    Prelims    Prelims         */
/********************************************************/

/* call close("STDOUT")
if open("STDOUT",'vdk:checkfile','w') then
  say "Checkfile open......" */



/************************************************************/
/*   Initializations    Initializations   Initializations   */
/************************************************************/

/*  constants  */

   true  = 1
   false = 0

   a = 1; b = 2; c = 3; d = 4; e = 5; f = 6; g = 7; h = 8
   fileletter = "a b c d e f g h"

/*  variables  */

    debugging = false
    do i = 1 to 8
      do j = 3 to 6
        square.i.j.piece = '0'   /* square vacant */
      end
    end
    do i = 1 to 8
      square.i.2.piece = "WP"
      square.i.7.piece = "BP"
    end
    square.a.1.piece = "WR";  square.a.8.piece = "BR"
    square.b.1.piece = "WN";  square.b.8.piece = "BN"
    square.c.1.piece = "WB";  square.c.8.piece = "BB"
    square.d.1.piece = "WQ";  square.d.8.piece = "BQ"
    square.e.1.piece = "WK";  square.e.8.piece = "BK"
    square.f.1.piece = "WB";  square.f.8.piece = "BB"
    square.g.1.piece = "WN";  square.g.8.piece = "BN"
    square.h.1.piece = "WR";  square.h.8.piece = "BR"

    #whiterooks = 2;   #whiteknights = 2
    #blackrooks = 2;   #blackknights = 2
    black_king_position = "58"
    positions_white_knights = "21 71"
    positions_white_rooks   = "11 81"
    positions_black_knights = "28 78"
    positions_black_rooks   = "18 88"

/* OTHER GLOBAL VARIABLES:
               move                 whites_turn
               startpiece           capturedpiece
               startfile            startrank
               finishfile           finishrank
               white_king_position  black_king_position
               startposition        finishposition
*/



/************************************************************/
/*      Main       Main      Main      Main       Main      */
/************************************************************/

oldfile = 'oldfile'
newfile = 'newfile'
call open(oldfile,arg(1),'r')
call open(newfile,'ram:'arg(1)'@','w')
line = "null"
do while (word(line,1)~="1")
  line = readln(oldfile)
end
do while ~EOF(oldfile)
  parse var line number whites_move blacks_move .
  select
    when (whites_move ~= "")&(blacks_move ~= "") then do
       /*   trace ?r  */
        call do_whites_turn()
         call do_blacks_turn()
        end
    when (whites_move ~= "")&(blacks_move = "") then do
         call do_whites_turn()
         new_black_move = "       "
         end
    otherwise do
      new_white_move = " "
      new_black_move = " "
    end
  end

  new_white_move = new_white_move||check_status_after_whites_move
  new_black_move = new_black_move||check_status_after_blacks_move
  newline = padleft(number," ",3) padright(new_white_move," ",9),
                                        padright(new_black_move," ",9)
  call writeln(newfile,newline)

  say "         "line"        "padright(new_white_move," ",9),
                                        padright(new_black_move," ",9)
  line = readln(oldfile)
end
call close(oldfile)
call close(newfile)
exit


/************************************************************/
/*                                                          */
/*   Functions    Functions     Functions      Functions    */
/*                                                          */
/************************************************************/

do_whites_turn:
/*call showboard()*/
if debugging then say "Entering fcn: do_whites_turn"
whites_turn = true
if debugging then say "WHITE'S TURN**********************"
call get_move_coordinates(whites_move)
startpiece = piece(startfile,startrank)
startposition  = value(char(whites_move,1))||char(whites_move,2)
finishposition = right(whites_move,2) /* this wrong if pawn promotion!!*/
capturedpiece = piece(finishfile,finishrank)
if capturedpiece = 'BN' then
   #blackknights = #blackknights - 1
  else if capturedpiece = 'BR' then
    #blackrooks  = #blackrooks - 1
if debugging then do
           say "startpiece    = " startpiece
           say "capturedpiece = "capturedpiece
           say "startfile     = " startfile
           say "startrank     = " startrank
           say "finishfile    = " finishfile
           say "finishrank    = " finishrank
end
/* call showboard() */
white_king_position = find_piece('WK','00') /* search all squares */
   /* trace ?r */
if (whites_move='O-O')|(whites_move='O-O-O') then
      new_white_move = whites_move
  else do
     new_white_move = convert_move(whites_move)
     if (#whiterooks=2)&(startpiece="WR") then
            call update_pos_white_rooks()
     if (#whiteknights=2)&(startpiece="WN") then
            call update_pos_white_knights()
   end
call update_board(whites_move)
/*if (number>23) then do
    call showboard()
    trace ?r 
  end */
black_king_position = find_piece('BK','00')
if king_in_check('B') then check_status_after_whites_move = '+'
    else check_status_after_whites_move = ""
if debugging then say "Leaving fcn: do_whites_turn"
return


update_pos_white_rooks:
/*  trace ?r */
start@ = value(startfile)||startrank
finish@ = value(finishfile)||finishrank
if (word(positions_white_rooks,1)=start@)
    then positions_white_rooks = word(positions_white_rooks,2)||" "||finish@
else  positions_white_rooks = word(positions_white_rooks,1)||" "||finish@
return


update_pos_white_knights:
start@ = value(startfile)||startrank
finish@ = value(finishfile)||finishrank
if (word(positions_white_knights,1)=finish@)
         then  positions_white_knights =,
                  word(positions_white_knights,2)||" "||finish@
else  positions_white_knights =,
                  word(positions_white_knights,1)||" "||finish@
return


do_blacks_turn:
/*if (number=3) then trace ?r*/
if debugging then say "Entering fcn: do_blacks_turn"
whites_turn = false
if debugging then say "BLACK'S TURN  **********************"
 /*   trace ?r */
call get_move_coordinates(blacks_move)
startpiece = piece(startfile,startrank)
capturedpiece = piece(finishfile,finishrank)
startposition  = value(char(blacks_move,1))||char(blacks_move,2)
finishposition = right(blacks_move,2)/* this wrong if pawn promotion!!*/
if capturedpiece = 'WN' then
        #whiteknights = #whiteknights - 1
     else if capturedpiece = 'WR' then
        #whiterooks  = #whiterooks - 1
if debugging then do
           say "startpiece    = " startpiece
           say "capturedpiece = "capturedpiece
           say "startfile     = " startfile
           say "startrank     = " startrank
           say "finishfile    = " finishfile
           say "finishrank    = " finishrank
        end
/*  call showboard()  */
black_king_position = find_piece('BK','00')
if debugging then say "blacks_position =  "black_king_position
if (blacks_move='O-O')|(blacks_move='O-O-O') then
      new_black_move = blacks_move
  else  do 
      new_black_move = convert_move(blacks_move)
      if (#blackrooks=2)&(startpiece="BR") then
         call update_pos_black_rooks()
      if (#blackknights=2)&(startpiece="BN") then
         call update_pos_black_knights()
    end
call update_board(blacks_move)
white_king_position = find_piece('WK','00')
if king_in_check('W') then check_status_after_blacks_move = '+'
    else check_status_after_blacks_move = ""
if debugging then say "Leaving fcn: do_blacks_turn"
return

update_pos_black_rooks:
start@ = value(startfile)||startrank
finish@ = value(finishfile)||finishrank
if (word(positions_black_rooks,1)=start@)
         then  positions_black_rooks =,
                  word(positions_black_rooks,2)||" "||finish@
else  positions_black_rooks =,
                  word(positions_black_rooks,1)||" "||finish@
return


update_pos_black_knights:
/*  trace ?r */
start@ = value(startfile)||startrank
finish@ = value(finishfile)||finishrank
if (word(positions_black_knights,1)=start@)
         then  positions_black_knights =,
                  word(positions_black_knights,2)||" "||finish@
else  positions_black_knights =,
                  word(positions_black_knights,1)||" "||finish@
return



convert_move:
if debugging then say "Entering convert_move"
move = arg(1)

if whites_turn then
     piece_color = 'W'
else
  piece_color = 'B'
if debugging then say "check status = "check_status
  peece = char(startpiece,2)
select
  when peece = "P" then return pawn_move(piece_color)
  when peece = "R" then return rook_move(piece_color)
  when peece = "N" then return knight_move(piece_color)
  otherwise do
    if (capturedpiece ~= '0') then capture_status = "x"
      else capture_status = ""
          return peece||capture_status||finishposition
  end
end
if debugging then say "Leaving convert_move"
end /**/


pawn_move:
if debugging then say "Entering pawn_move"
/* if (number=45) then trace ?r */
if pawn_was_promoted() then
  promotion_piece = '/'upper(right(move,1))
else promotion_piece = ""
positionfinal=char(move,3)||char(move,4)
if motion_along_same_file() then do
        if debugging then say "Leaving fcn: pawn_move"
        return positionfinal||promotion_piece
       end
   else if en_passant() then do
          call remove_en_passant_captured_piece()
          return startfile||"x"||positionfinal||,
                      "ep"||promotion_piece
            end
         else do
             if debugging then say "Leaving fcn: pawn_move"
           return startfile||"x"||positionfinal||promotion_piece
           end
   end


pawn_was_promoted:
if (pos(right(move,1),"nrbq")>0) then return true
  else return false

motion_along_same_file:
if (finishfile=startfile) then return true
  else return  false


en_passant:
/*  trace ?r */
if (capturedpiece='0') then return true
  else return false

remove_en_passant_captured_piece:
zero_out_file = value(finishfile)
zero_out_rank = startrank
square.zero_out_file.zero_out_rank.piece = '0'
return

knight_move:
if debugging then say "Entering fcn: knight_move"
start = right(startpiece,1)
if whites_turn then do /**/
  if (#whiteknights=2) then
    if both_knights_could_take_sqr() then
      if both_knights_on_same_file() then
            start = right(startpiece,1)||startrank
        else
            start = right(startpiece,1)||startfile
 end /**/
else do    /* it's black's turn */
  if (#blackknights=2) then
     if both_knights_could_take_sqr() then
       if both_knights_on_same_file() then
            start = right(startpiece,1)||startrank
        else
            start = right(startpiece,1)||startfile
end
if (capturedpiece ~= '0') then capture_status = "x"
   else capture_status = ""
if debugging then say "Leaving knight_move"
return start||capture_status||finishposition


both_knights_could_take_sqr:
/*if (number=12) then do
  say "Entering fcn: both_knights_could_take_sqr"
  call showboard()
  trace ?r
end*/
if debugging then say "Entering fcn: both_knights_could_take_sqr"
if whites_turn then do
    enemy_knight = 'WN'
    enemy_king_color = 'B'
    end
  else do
    enemy_knight = 'BN'
    enemy_king_color = 'W'
  end
ignore_this_square = startposition
position_other_knight = find_knight(ignore_this_square)
/* temporarily put an enemy king on capture square and then
       see if the king is in check! */
tempmove                = move 
tempstartpiece          = startpiece
tempcapturedpiece       = capturedpiece
fpos = file(startposition)
rpos = rank(startposition)
square.fpos.rpos.piece = "0"
fp = finishposition
if whites_turn then do
    tempblack_king_position = black_king_position
    white_king_position = value(char(fp,1))||char(fp,2)
    enemy_king_color = 'B'
   end
  else do
    tempwhite_king_position = white_king_position
    black_king_position = value(char(fp,1))||char(fp,2)
    enemy_king_color = 'W'
  end
king_file = value(char(fp,1))
king_rank = char(fp,2)
if check_by_knight(enemy_king_color) then
    check_value = true
else   check_value = false
move                = tempmove 
startpiece          = tempstartpiece
capturedpiece       = tempcapturedpiece
square.fpos.rpos.piece = enemy_knight
if whites_turn then
  black_king_position = tempblack_king_position
else
  white_king_position = tempwhite_king_position
if debugging then say "Leaving fcn: both_knights_could_take_sqr"

return check_value


both_knights_on_same_file:
if whites_turn then do
  file1 = left(word(positions_white_knights,1),1)
  file2 = left(word(positions_white_knights,2),1)
  end
else do
  file1 = left(word(positions_black_knights,1),1)
  file2 = left(word(positions_black_knights,2),1)
end
if (file1=file2) then return true
    else return false


find_knight:
if whites_turn then
  if (word(positions_white_knights,1)=ignore_this_square)
         then  return  word(positions_white_knights,2)
  else  return  word(positions_white_knights,1)
if (word(positions_black_knights,1)=ignore_this_square)
         then  return  word(positions_black_knights,2)
  else  return  word(positions_black_knights,1)



rook_move:
if debugging then say "Entering fcn: rook_move"
/*if (number=33)&(~whites_turn) then do
   call showboard()
   trace ?r 
end*/
start = right(startpiece,1)
if whites_turn then do /**/
  if (#whiterooks=2) then
    if both_rooks_could_take_sqr() then do /****/
      /*if (number=30) then    trace ?r*/
      if both_rooks_on_same_file() then
            start = start||startrank
        else   start = start||startfile
    end /****/
 end /**/
else do    /* it's black's turn */
  start = right(startpiece,1)
  if (#blackrooks=2) then
     if both_rooks_could_take_sqr() then
       if both_rooks_on_same_file() then
            start = start||startrank
          else   start = start||startfile
end
if (capturedpiece ~= '0') then capture_status = "x"
   else capture_status = ""
if debugging then say "Leaving fcn: rook_move"
return start||capture_status||finishposition


both_rooks_on_same_file:
/*if (number=25)&(whites_turn) then  trace ?r*/
if debugging then say "Entering fcn: both_rooks_on_same_file"
if (value(startfile)=left(position_other_rook,1)) then return true
  else return false



both_rooks_on_same_rank:
/*if (number=30)&(whites_turn) then    trace ?r */
if debugging then say "Entering fcn: both_rooks_on_same_rank"
if (startrank=right(position_other_rook,1)) then return true
  else return false



both_rooks_could_take_sqr:
/*if (number=30)&(whites_turn) then    trace ?r */
if debugging then say "Entering fcn: both_rooks_could_take_sqr"
if whites_turn then rook = 'WR'
  else  rook = 'BR'
ignore_this_square = value(startfile)||startrank
position_other_rook = find_rook(ignore_this_square)
if (value(file(position_other_rook))=value(finishfile)) then do
    r1 = rank(finishposition)
    r2 = rank(position_other_rook)
    if other_rook_could_move_along_file(r1,r2) then return true
   end
else if (rank(position_other_rook)=finishrank)  then do
    f1 = finishfile
    f2 = file(position_other_rook)
    if other_rook_could_move_along_rank(f1,f2) then return true
   end
if debugging then say "Leaving fcn: both_rooks_could_take_sqr"
return false


find_rook:
/*if (number=30) then    trace ?r */
if whites_turn then
  if (word(positions_white_rooks,1)=ignore_this_square)
         then  return  word(positions_white_rooks,2)
  else  return  word(positions_white_rooks,1)
if (word(positions_black_rooks,1)=ignore_this_square)
         then  return  word(positions_black_rooks,2)
  else  return  word(positions_black_rooks,1)






other_rook_could_move_along_file:
/*if (number=30)&(whites_turn) then do
  trace ?r
  call showboard()
end*/
if debugging then say "Entering fcn: other_rook_could_move_along_file"
target_rank = arg(1) 
other_pieces_start_rank = arg(2)
file# = value(finishfile)
if (abs(target_rank-other_pieces_start_rank)=1) then return true
if (target_rank > other_pieces_start_rank) then
    do k = other_pieces_start_rank+1 to target_rank
      departure_rank = k
      if (piece(file#,k)~='0') then  do
          leave k
        end
    end
else
    do k = other_pieces_start_rank-1 to target_rank by -1
      departure_rank = k
      if (piece(file#,k)~='0') then   leave k
    end
if (departure_rank = target_rank) then do
    if debugging then say "Leaving: other_rook_could_move_along_file"
     if ~piece_pinned(position_other_rook) then
        return true
  end
if debugging then say "Leaving fcn: other_rook_could_move_along_file"
return false


other_rook_could_move_along_rank:
/*if (number=30)&(whites_turn) then  trace ?r */
if debugging then say "Entering fcn: other_rook_could_move_along_rank"
target_file = value(arg(1)) 
other_pieces_start_file = value(arg(2)) 
if (abs(target_file-other_pieces_start_file)=1) then return true
if (target_file > other_pieces_start_file) then
    do k = other_pieces_start_file+1 to target_file
        departure_file = k
        if (piece(k,finishrank)~='0') then do
           leave k
         end
    end
else
    do k = other_pieces_start_file-1 to target_file by -1
        departure_file = k
        if (piece(k,finishrank)~='0') then  do
          leave k
        end
    end
if (departure_file = target_file) then do
     if debugging then say "Leaving: other_rook_could_move_along_rank"
     if ~piece_pinned(position_other_rook) then
        return true
     end
if debugging then say "Leaving fcn: other_rook_could_move_along_rank"
return false


piece_pinned: /* piece is pinned if removing it causes check! */
if debugging then say "Entering fcn: piece_pinned"
position_of_piece = arg(1)
file$ = value(file(position_of_piece))
rank$ = rank(position_of_piece)
temp = square.file$.rank$.piece
square.file$.rank$.piece = '0'
if whites_turn then color = 'W'
  else color = 'B'
if king_in_check(color) then do
     square.file$.rank$.piece = temp
     if debugging then say "Leaving fcn: piece_pinned"
     return true
    end
  else do
     square.file$.rank$.piece = temp
       if debugging then say "Leaving fcn: piece_pinned"
      return false
  end




update_board: 
if debugging then say "Entering fcn: update_board"
/*  trace ?r */
move = arg(1)
if whites_turn then do
        rank# = 1
        piece_colour = 'W'
     end
  else do
    rank# = 8
    piece_colour = 'B'
  end
select
  when (move = 'O-O') then 
    call get_rook_pos_updated_for_kingside_castle()
  when (move = 'O-O-O') then
    call get_rook_pos_updated_for_queenside_castle()
  otherwise do /****/
    startsfile     =  value(startfile)
    finishesfile    =  value(finishfile)
    square.startsfile.startrank.piece = '0'
    if pawn_was_promoted() then
       square.finishesfile.finishrank.piece =,
                         piece_colour||upper(right(move,1))
    else
       square.finishesfile.finishrank.piece = startpiece
  end /****/
end /* select */
if debugging then say "Leaving fcn: update_board"
return


get_rook_pos_updated_for_kingside_castle:
/*  trace ?r */
select
  when whites_turn then do
    if (word(positions_white_rooks,1)="81") then 
      positions_white_rooks =,
               "61 "||word(positions_white_rooks,2)
    else    positions_white_rooks =,
               "61 "||word(positions_white_rooks,1)
   end
  when ~whites_turn then /* It's black's turn */
    if (word(positions_black_rooks,1)="88") then 
      positions_black_rooks =,
               "68 "||word(positions_black_rooks,2)
    else    positions_black_rooks =,
               "68 "||word(positions_black_rooks,1)
  otherwise NOP
end /* select  */
square.e.rank#.piece = '0'
square.f.rank#.piece =  piece_colour||'R'
square.g.rank#.piece =  piece_colour||'K'
square.h.rank#.piece = '0'
return

get_rook_pos_updated_for_queenside_castle:
select
  when whites_turn then
    if (word(positions_white_rooks,1)="11") then 
      positions_white_rooks =,
               "41 "||word(positions_white_rooks,2)
    else    positions_white_rooks =,
               "41 "||word(positions_white_rooks,1)
  when ~whites_turn then /* It's black's turn */
    if (word(positions_black_rooks,1)="18") then 
      positions_black_rooks =,
               "48 "||word(positions_black_rooks,2)
    else    positions_white_rooks =,
               "48 "||word(positions_black_rooks,1)
  otherwise NOP
end /* select  */
square.a.rank#.piece = '0'
square.d.rank#.piece =  piece_colour||'R'
square.c.rank#.piece =  piece_colour||'K'
square.e.rank#.piece = '0'
return


pawn_was_promoted:
if debugging then say "Entering fcn: pawn_was_promoted"
if (startrank = 7)&(startpiece = 'WP') then return true
  else if (startrank = 2)&(startpiece = 'BP') then return true
  else return false



/************************************************************/
/*    king_in_check    king_in_check    king_in_check       */
/************************************************************/

king_in_check:
if debugging then say "Entering fcn: king_in_check"
/*if (number=12) then  do
  call showboard()
  trace ?r 
end*/
king_color = arg(1)  /* This is the color of the current turn's enemy */
if (king_color='W') then do
    king_position = white_king_position
    opposite_king_color = 'B'
    testing_for_check_against_white = true
    enemy_knight = 'BN'
    enemy_rook   = 'BR'
    enemy_bishop = 'BB'
    enemy_queen  = 'BQ'
    end
  else do 
    king_position = black_king_position
    testing_for_check_against_white = false
    opposite_king_color = 'W'
    enemy_knight = 'WN'
    enemy_rook   = 'WR'
    enemy_bishop = 'WB'
    enemy_queen  = 'WQ'
    end
king_file = file(king_position)
king_rank = rank(king_position)
if check_by_pawn(king_color) then return true
else if check_by_knight(king_color) then return true
else if check_by_bishop_or_queen(king_color) then return true
else if check_by_rook_or_queen(king_color) then return true
if debugging then say "Leaving fcn: king_in_check"
return false



/************************************************************/
/*     check-discovery tools    check-discovery tools       */
/************************************************************/

check_by_pawn:
if debugging then say "Entering fcn: check_by_pawn"
/*  trace ?r */
king_colour = arg(1)
if (king_colour = 'W') then do
     king_position = white_king_position
     testing_for_check_against_white = true
    end
  else do
    king_position = black_king_position
    testing_for_check_against_white = false
    end
king_file = file(king_position)
king_rank = rank(king_position)
if testing_for_check_against_white then do
   /* look at diagonal squares of greater rank by 1 */
    if (king_rank>6) then return false
    select
      when (king_file=a) then
         if pawn_check_from_NE(king_colour) then return true
              else return false
      when (king_file=h) then
        if pawn_check_from_NW(king_colour) then return true
              else return false
      otherwise
        if pawn_check_from_NE(king_colour)|pawn_check_from_NW(king_colour)
           then return true
         else return false
    end /* select */
  end
else do
   /* look at diagonal squares of lesser rank by 1 */
    select
      when (king_rank<3) then return false
      when (king_file=a) then
        if pawn_check_from_SE(king_colour) then return true
          else return false
      when (king_file=h) then
        if pawn_check_from_SW(king_colour) then return true
          else return false
      otherwise
       if pawn_check_from_SE(king_colour)|pawn_check_from_SW(king_colour)
         then return true
         else do
           if debugging then say "Leaving fcn: check_by_pawn"
           return false
         end
    end /* select */
  end



pawn_check_from_NE:/*  trace ?r */
if debugging then say "Entering fcn: pawn_check_from_NE"
king_color = arg(1)
peece = piece(king_file+1,king_rank+1)
if (right(peece,1)='P')&,
    (piece_color(king_file+1,king_rank+1)=opposite_color(king_color))
   then return true
if debugging then say "Leaving fcn: pawn_check_from_NE"
return false


pawn_check_from_NW: 
if debugging then say "Entering fcn: pawn_check_from_NW"
king_color = arg(1)
if (right(piece(king_file-1,king_rank+1),1)='P')&,
    (piece_color(king_file-1,king_rank+1)=opposite_color(king_color))
   then return true
if debugging then say "Leaving fcn: pawn_check_from_NW"
return false


pawn_check_from_SW:
if debugging then say "Entering fcn: pawn_check_from_SW"
king_color = arg(1)
if (right(piece(king_file-1,king_rank-1),1)='P')&,
    (piece_color(king_file-1,king_rank-1)=opposite_color(king_color))
   then return true
if debugging then say "Leaving fcn: pawn_check_from_SW"
return false



pawn_check_from_SE:
if debugging then say "Entering fcn: pawn_check_from_SE"
king_color = arg(1)
if (right(piece(king_file+1,king_rank-1),1)='P')&,
    (piece_color(king_file+1,king_rank-1)=opposite_color(king_color))
   then return true
if debugging then say "Leaving fcn: pawn_check_from_SE"
return false




/**************************************************************/

check_by_knight:
if debugging then say "Entering fcn: check_by_knight"
if (king_file > a) then /* can't allow negative values */
  if (piece(king_file-1,king_rank+2)=enemy_knight)
      then return true
if (king_file > a)&(king_rank > 2) then
  if (piece(king_file-1,king_rank-2)=enemy_knight)
      then return true
if (piece(king_file+1,king_rank+2)=enemy_knight)
      then return true
if (king_rank > 2) then
  if (piece(king_file+1,king_rank-2)=enemy_knight)
      then return true
if (king_file > b) then
  if (piece(king_file-2,king_rank+1)=enemy_knight)
      then return true
if (king_file > b)&(king_rank > 1) then
  if (piece(king_file-2,king_rank-1)=enemy_knight)
      then return true
if (piece(king_file+2,king_rank+1)=enemy_knight)
      then return true
if (king_rank > 1) then
  if (piece(king_file+2,king_rank-1)=enemy_knight)
      then return true
if debugging then say "Leaving fcn: check_by_knight"
return false

/******************************************************/

check_by_bishop_or_queen:
if debugging then say "Entering fcn: check_by_bishop_or_queen" 
    /* look northeastward */
if (king_file = h)|(king_rank = 8) then NOP
  else do
    do j = 1 to 8   while (king_rank+j<=8)&(king_file+j<8)
       if (piece(king_file+j,king_rank+j)~='0') then leave j
    end
    peece = piece(king_file+j,king_rank+j)
    if (peece=enemy_bishop)|(peece=enemy_queen)
       then return true
  end
 /* look southwestward */
 if (king_file = a)|(king_rank = 1) then NOP
   else do
     do j = 1 to king_file  while (king_rank-j>=1)&(king_file-j>=1)
        if (piece(king_file-j,king_rank-j)~='0') then leave
     end
     peece = piece(king_file-j,king_rank-j)
     if (peece=enemy_bishop)|(peece=enemy_queen)
         then return true
   end
 /* look northwestward */
 if (king_file = a)|(king_rank = 8) then NOP
   else do
     do j = 1 to king_file-1  while (king_rank+j<=8)&(king_file-j>=1)
        if (piece(king_file-j,king_rank+j)~='0') then leave
     end
    peece = piece(king_file-j,king_rank+j)
    if (peece=enemy_bishop)|(peece=enemy_queen)
         then return true
   end
 /* look southeastward */
 if ~((king_file = h)|(king_rank = 1)) then do
     do j = 1 to 8   while (king_rank-j>=1)&(king_file+j<=8)
        if (piece(king_file+j,king_rank-j)~='0') then leave
     end
     peece = piece(king_file+j,king_rank-j)
     if (peece=enemy_bishop)|(peece=enemy_queen)
        then return true
   end
if debugging then say "Leaving fcn: check_by_bishop_or_queen" 
return false


/*******************************************************/

check_by_rook_or_queen: 
/*if (number=7) then trace ?r*/
if debugging then say "Entering fcn: check_by_rook_or_queen" 
/*  trace */
   /* look northward */
    if (king_rank < 8) then do
        do j = king_rank+1 to 8
           if (piece(king_file,j)~='0') then leave
        end
        peece = piece(king_file,j)
        if (peece=enemy_rook)|(peece=enemy_queen)
           then return true
      end
    /* look southward */
    if (king_rank > 1) then do
        do j = king_rank-1 to 1 by -1 
          if (piece(king_file,j)~='0') then leave
        end
        peece = piece(king_file,j)
        if (peece=enemy_rook)|(peece=enemy_queen)
         then return true
      end
   /* look eastward */
    if (king_file < h) then do
        do j = king_file+1 to 8
           if (piece(j,king_rank)~='0') then leave
        end
        peece = piece(j,king_rank)
        if (peece=enemy_rook)|(peece=enemy_queen)
           then return true
      end
   /* look westward */
    if (king_file > a) then do
        do j = king_file-1 to 1 by -1
          if (piece(j,king_rank)~='0') then leave
        end
        peece = piece(j,king_rank)
        if (peece=enemy_rook)|(peece=enemy_queen)
           then return true
      end
if debugging then say "Leaving fcn: check_by_rook_or_queen" 
return false



/*******************************************************************/
/*                                                                 */
/*      general tools      general tools      general tools        */
/*                                                                 */
/*******************************************************************/


piece: procedure expose square. a b c d e f g h debugging 
file = value(arg(1))
rank = arg(2)
return square.file.rank.piece

piece_color: procedure expose square. debugging
file = arg(1)
rank = arg(2)
return char(square.file.rank.piece,1)



get_move_coordinates:
if debugging then say "Entering fcn: get_move_coordinates" 
/*  trace ?r */
move = arg(1)
if (move='O-O') then do
  startfile  = e
  finishfile = g
  if whites_turn then do
    startrank  = 1
    finishrank = 1
    end
  else do
    startrank  = 8
    finishrank = 8
  end
end
else if (move='O-O-O') then do
  startfile  = e
  finishfile = c
  if whites_turn then do
    startrank  = 1
    finishrank = 1
    end
  else do
    startrank  = 8
    finishrank = 8
  end
end
else do
  startfile  = char(move,1)
  startrank  = char(move,2)
  finishfile = char(move,3)
  finishrank = char(move,4)
end
if debugging then say "Leaving fcn: get_move_coordinates" 
return


file: return char(arg(1),1)


rank: return char(arg(1),2)


position: return arg(1)||arg(2)


opposite_color: procedure expose debugging
if (arg(1)='W') then return 'B'
  else return 'W'




find_piece: procedure expose true false square. debugging 
if debugging then say "Entering fcn: find_piece"
/*  trace ?r */
search_piece  = arg(1)
sqr_to_ignore = arg(2)
do i = 1 to 8
  do j = 1 to 8
    sqr = i||j
    if (sqr~=sqr_to_ignore) then
      if (piece(i,j)=search_piece) then
         return i||j
  end
end
return "Cannot find piece"


store_board: procedure expose square. temp_square. debugging
if debugging then say "Entering fcn: store_board"
do u = 1 to 8
  do v = 1 to 8
    temp_square.u.v.piece = square.u.v.piece
  end
end
if debugging then say "Leaving fcn: store_board"
return


vacate_board: procedure expose square. temp_square. debugging
if debugging then say "Entering fcn: vacate_board"
do file = 1 to 8
  do rank = 1 to 8
    square.file.rank.piece = '0'
  end
end
if debugging then say "Leaving fcn: vacate_board"
return


recover_board: procedure expose square. temp_square. debugging
if debugging then say "Entering fcn: recover_board"
do u = 1 to 8
  do v = 1 to 8
    square.u.v.piece = temp_square.u.v.piece
  end
end
if debugging then say "Leaving fcn: recover_board"
return



showboard:
writeln("STDOUT"," ")
do updown = 8 to 1 by -1
  do across = 1 to 8
    if (across=8) then do writech("STDOUT"," ")
                writech("STDOUT",left(square.across.updown.piece,1))
                writeln("STDOUT",right(square.across.updown.piece,1))
              end
        else do writech("STDOUT"," ")
                writech("STDOUT",left(square.across.updown.piece,1))
                writech("STDOUT",right(square.across.updown.piece,1))
             end
  end
end
writeln("STDOUT"," ")
return




char: procedure
string = arg(1)
index  = arg(2)
if index > length(string) then return 0
  else return substr(string,index,1)


padleft:
string    = arg(1)
padchar   = arg(2)
padlength = arg(3)
len = length(string)
if len<padlength then do
      do i=1 to padlength-len
         string = padchar||string
      end
  end
return string


padright:
string    = arg(1)
padchar   = arg(2)
padlength = arg(3)
len = length(string)
if len<padlength then do
      do i=1 to padlength-len
         string = string||padchar
      end
  end
return string

